# screeps typing
class st:  # ScreepsTyping
    """
    st提供了一组形如st.funcx(obj)->bool的函数</br>
    """

    @staticmethod
    def na(obj: object) -> bool:
        """
        判断一个对象是否是py None | Determine if an object is py None  
        * python的None由于翻译可能有问题，有时会翻译为Null或者undefined，所以使用该函数代替is None检查   
           Because the translation of python's None may have problems, sometimes it may be translated as Null or undefined, so use this function instead of 'is None' check

        Args:
            obj:

        Returns:
            bool            bool
        """
        pass

    @staticmethod
    def site(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:ConstructionSite   
        Determine if an object is a game object:ConstructionSite

        Args:
            obj:

        Returns:
            bool            bool
        """
        pass

    @staticmethod
    def creep(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Creep   
        Determine if an object is a game object:Creep

        Args:
            obj:

        Returns:
            bool            bool
        """
        pass

    @staticmethod
    def gobject(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象   
        Determine if an object is a game object

        Args:
            obj:

        Returns:
            bool            bool
        """
        pass

    @staticmethod
    def ostructure(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:OwnedStructure   
        Determine if an object is a game object:OwnedStructure

        Args:
            obj:

        Returns:
            bool            bool
        """
        pass

    @staticmethod
    def resource(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Resource   
        Determine if an object is a game object:Resource

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def source(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Source   
        Determine if an object is a game object:Source

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def store(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Store   
        Determine if an object is a game object:Store

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def structure(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Structure   
        Determine if an object is a game object:Structure

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def box(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureContainer   
        Determine if an object is a game object:StructureContainer

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def extension(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureExtension   
        Determine if an object is a game object:StructureExtension

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def rampart(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureRampart   
        Determine if an object is a game object:StructureRampart

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def road(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureRoad   
        Determine if an object is a game object:StructureRoad

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def spawn(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Spawn   
        Determine if an object is a game object:Spawn

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def tower(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureTower   
        Determine if an object is a game object:StructureTower

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def wall(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:StructureWall   
        Determine if an object is a game object:StructureWall

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def flag(obj: object) -> bool:
        """
        判断一个对象是否是 游戏对象:Flag   
        Determine if an object is a game object:Flag

        Args:
            obj:

        Returns:
            bool
        """
        pass

    # -------------------------------------- 对象能力判断 | Object Ability Type Judgment -----------------

    @staticmethod
    def movable(obj: object) -> bool:
        """
        判断一个game object是否可以移动   
        Determine if a game object can move

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def atkable(obj: object) -> bool:
        """
        判断一个game object是否可以攻击(或远程攻击)   
        Determine if a game object can attack (or ranged attack)

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def melee(obj: object) -> bool:
        """
        判断一个game object是否可以近战攻击   
        Determine if a game object can melee attack

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def ranged(obj: object) -> bool:
        """
        判断一个game object是否可以远程攻击   
        Determine if a game object can ranged attack

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def healable(obj: object) -> bool:
        """
        判断一个game object是否可以治疗他人   
        Determine if a game object can heal others

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def hitable(obj: object) -> bool:
        """
        判断一个game object是否可以被攻击   
        Determine if a game object can be attacked

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def workable(obj: object) -> bool:
        """
        判断一个game object是否可以工作   
        Determine if a game object can work

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def storable(obj: object) -> bool:
        """
        判断一个game object是否可以储存资源(和现有资源情况无关)   
        Determine if a game object can store resources (regardless of the current resource situation)

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def dynamicMovable(obj: object) -> bool:
        """
        判断一个creep是否可以移动   
        Determine if a creep can move

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def dynamicAtkable(obj: object) -> bool:
        """
        判断一个creep是否可以攻击(或远程攻击)   
        Determine if a creep can attack (or ranged attack)

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def dynamicMelee(obj: object) -> bool:
        """
        判断一个creep是否可以近战攻击   
        Determine if a creep can melee attack

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def dynamicRanged(obj: object) -> bool:
        """
        判断一个creep是否可以远程攻击   
        Determine if a creep can ranged attack

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def dynamicHealable(obj: object) -> bool:
        """
        判断一个creep是否可以治疗他人   
        Determine if a creep can heal others

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def dynamicWorkable(obj: object) -> bool:
        """
        判断一个creep是否可以工作   
        Determine if a creep can work

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def dynamicStorable(obj: object) -> bool:
        """
        判断一个creep是否可以储存   
        Determine if a creep can store

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def energetic(obj: object) -> bool:
        """
        判断一个game object是否可以被单位拿取到能量   
        Determine if a game object can be picked up by a unit

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def scoretic(obj: object) -> bool:
        """
        判断一个game object是否可以被单位拿取到分数   
        Determine if a game object can be picked up by a unit to score

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def scoreticX(obj: object) -> bool:
        """
        判断一个game object是否可以被单位拿取到分数X   
        Determine if a game object can be picked up by a unit to scoreX

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def scoreticY(obj: object) -> bool:
        """
        判断一个game object是否可以被单位拿取到分数Y   
        Determine if a game object can be picked up by a unit to scoreY

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def scoreticZ(obj: object) -> bool:
        """
        判断一个game object是否可以被单位拿取到分数Z   
        Determine if a game object can be picked up by a unit to scoreZ

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def damaged(obj: object) -> bool:
        """
        判断一个game object是否受损   
        Determine if a game object is damaged

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def empty(obj: object) -> bool:
        """
        判断一个对象的store是否为空(特指RESOURCE_ENERGY)   
        Determine if an object's store is empty (specifically RESOURCE_ENERGY)

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def full(obj: object) -> bool:
        """
        判断一个对象的store是否满(特指RESOURCE_ENERGY)   
        Determine if an object's store is full (specifically RESOURCE_ENERGY)

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def friend(obj: object) -> bool:
        """
        判断一个game object是否是友方   
        Determine if a game object is friendly

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def my(obj: object) -> bool:
        """
        判断一个game object是否是己方   
        Determine if a game object is my

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def enemy(obj: object) -> bool:
        """
        判断一个game object是否是敌方   
        Determine if a game object is an enemy

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def neutral(obj: object) -> bool:
        """
        判断一个game object是否是中立   
        Determine if a game object is neutral

        Args:
            obj:

        Returns:
            bool
        """
        pass

    @staticmethod
    def point(obj: object) -> bool:
        """
        判断一个对象是否是一个坐标点(具有x和y属性)   
        Determine if an object is a coordinate point (with x and y properties)

        Args:
            obj:

        Returns:
            bool
        """
        pass
